`timescale 1ns / 1ps
// Anthony Curnes
// This is a 3-to-8 bit decoder
module dec3to8(out, in);
    // input and output declarations
    output [7:0] out;
    input [2:0] in;

    // out is assigned an 8-bit binary value with only
    // one bit actually set, the bit set corresponds to the
    // value of the input
    assign out =    in == 3'b000 ? 8'b00000001 :
                    in == 3'b001 ? 8'b00000010 :
                    in == 3'b010 ? 8'b00000100 :
                    in == 3'b011 ? 8'b00001000 :
                    in == 3'b100 ? 8'b00010000 :
                    in == 3'b101 ? 8'b00100000 :
                    in == 3'b110 ? 8'b01000000 :
                    in == 3'b111 ? 8'b10000000 : 1'b0;


endmodule
